<?php
require "MConsultas.php";
require "MInit.php";
require "MDeleter.php";
require "MActualizer.php";
require "MInserter.php";


$body = json_decode(file_get_contents("php://input"), true);
$funcion=$body['funcion'];

// Devuelve todos los cuentas
 if ($funcion=='get_cuentasban'){	
	$buscado=$body['buscado'];	
	$condicion="WHERE descripcion like '%".$buscado."%' ORDER BY descripcion ASC;";	
	$columnas="id_cuenta, numcuenta, clabe, descripcion, imagen, saldo, activa";
	$res=consultar("m_cuentasban", $columnas, $condicion);	
	echo responder($res);
}

// cuentas para selector
 if ($funcion=='get_allcuentas'){
	$condicion="ORDER BY descripcion ASC;";	
	$columnas="id_cuenta, descripcion, saldo, imagen";
	$res=consultar("m_cuentasban", $columnas, $condicion);	
	echo responder($res);
}

//SALDO CUENTA
 if ($funcion=='get_saldocuentaban'){		
	$nombre=$body['nombre'];	
	$res=consultar("m_cuentasban", "saldo","WHERE descripcion='".$nombre."';");	
	echo responder($res);
}

// Actualiza saldo
if ($funcion=='upd_saldocuentaban'){	
	$nombre=$body['nombre'];	
	$saldo=$body['saldo'];	
	$condicion="WHERE descripcion='".$nombre."';";		
	$res=actualizar("m_cuentasban", "saldo", $saldo, $condicion);	
	echo $res;
}

// Actualiza los datos de un cuentas
if ($funcion=='upd_cuentaban'){
	$id_cuenta=$body['id_cuenta'];	
	$valores=$body['valores'];	
	$condicion="WHERE id_cuenta='".$id_cuenta."';";	
	$columnas="numcuenta|clabe|descripcion|imagen|activa";	
	$res=actualizar("m_cuentasban", $columnas, $valores, $condicion);	
	echo $res;
}
  
  // Inserta un cuentas
  if ($funcion=='add_cuentaban'){		
	$valores=$body['valores'];	
	$columnas="numcuenta|clabe|descripcion|imagen|activa";		
	$res=insertar("m_cuentasban", $columnas, $valores);	
	echo $res;
  }
	
  // Borrar cuentas
	if ($funcion=='del_cuentaban'){		
	$id_cuenta=$body['id_cuenta'];	
	$condicion="WHERE id_cuenta='".$id_cuenta."';";		
	$res=eliminar("m_cuentasban", $condicion);	
	echo $res;
}
	
	
	
	
//*** DETALLE DE CUENTASBAN

// detalles cuentas para modulo
 if ($funcion=='get_detallesCuentas'){
	$condicion="WHERE estado='Pendiente' ORDER BY tiempo desc;";	
	$columnas="id_detalle, id_usuario, cuenta, tipo, concepto, monto, referencia, tiempo, estado";
	$res=consultar("m_detalletranscue", $columnas, $condicion);	
	echo responder($res);
}

// Inserta un detalle cuenta
  if ($funcion=='add_dettrancue'){		
	$valores=$body['valores'];	
	$columnas="cuenta|tipo|concepto|monto|referencia|tiempo|id_usuario|estado";		
	$res=insertar("m_detalletranscue", $columnas, $valores);	
	echo $res;
  }
  
  // Borrar detalle cuenta
	if ($funcion=='del_dettrancue'){		
	$id_detalle=$body['id_detalle'];	
	$condicion="WHERE id_detalle='".$id_detalle."' and estado='Pendiente';";		
	$res=eliminar("m_detalletranscue", $condicion);	
	echo $res;
}

// actualizar estado de detalle de cuenta
if ($funcion=='upd_edotrancue'){
	$id_detalle=$body['id_detalle'];	
	$estado=$body['estado'];	
	$condicion="WHERE id_detalle='".$id_detalle."';";	
	$res=actualizar("m_detalletranscue", "estado", $estado, $condicion);	
	echo $res;
}






// APLICA LAS TRANSACCIONES PENDIENTES
if ($funcion=='upd_transactsCue'){	
	$condicion="WHERE estado='Pendiente' ORDER BY tiempo desc;";	
	$columnas="id_detalle, cuenta, tipo, monto";
	$ldetalles=consultar("m_detalletranscue", $columnas, $condicion);	
	
	$ccue= new Ccuentasban();
	$arrDets= explode (">",$ldetalles);	
	foreach ($arrDets as $lindet){
		$arrVals=explode ("|",$lindet);
		$id_detalle=$arrVals[0];
		$nombreCta=$arrVals[1];
		$trtipo=$arrVals[2];		
		$trmonto=$arrVals[3];
		$ccue->upd_edotrancue($id_detalle, "Aplicado");
		$ccue->afectar_cuenta($trtipo, $nombreCta, $trmonto);		
	}		
	echo responder("OK");
}





//CLASE PRINCIPAL PARA APLICAR TRANSACCIONES EN CUENTAS
class Ccuentasban{	
	
	public function afectar_cuenta($trtipo, $nombreCta, $trmonto){
		$saldo_nvo=0;
		$saldo_ant=$this->get_saldoCuentaban($nombreCta);		
		if ($trtipo=="INGRESO"){			
			$saldo_nvo= $saldo_ant+$trmonto;
			if($saldo_ant!=$saldo_nvo){
				$this->upd_saldocuentaban($saldo_nvo, $nombreCta);				
			}
		}		
		if ($trtipo=="EGRESO"){			
			$saldo_nvo= $saldo_ant-$trmonto;
			if($saldo_ant!=$saldo_nvo){
				$this->upd_saldocuentaban($saldo_nvo, $nombreCta);				
			}
		}		
	}
	
	
	public function get_saldoCuentaban($nombreCta){
		$res=consultar("m_cuentasban", "saldo","WHERE descripcion='".$nombreCta."';");
		return $res;
	}
	
	public function upd_saldocuentaban($nvosaldo, $nombreCta){			
		$res=actualizar("m_cuentasban", "saldo", $nvosaldo, "WHERE descripcion='".$nombreCta."';");
		return $res;
	}
	
	public function upd_edotrancue($id_detalle, $estado){
		$res=actualizar("m_detalletranscue", "estado", $estado, "WHERE id_detalle='".$id_detalle."';");
		return $res;
	}
	
	
}






  

?>