<?php
require "MConsultas.php";
require "MInserter.php";
require "MActualizer.php";
require "MDeleter.php";
require "MInit.php";

date_default_timezone_set('America/Mexico_City');
$body = json_decode(file_get_contents("php://input"), true);
$funcion=$body['funcion'];

//*** CITAS 

if ($funcion=='get_citasmes'){	
	$nummes=$body['nummes'];
	$anio=$body['anio'];
	$id_usuario=$body['id_usuario'];
	$columnas="id_cita, id_producto, id_usuario, id_cliente, id_vendedor, descripcion, estado, detalles, fecha_ini, fecha_fin, hora_ini, hora_fin, nomprecio, descuento, duracion, unidad_dur";
	$condicion="WHERE MONTH(fecha_ini)='".$nummes."' and YEAR(fecha_ini)='".$anio."' and id_usuario='".$id_usuario."' and (estado='Pendiente' or estado='Cobrada') order by fecha_ini asc ;";		
	$res=consultar("m_citas", $columnas, $condicion);	
	echo responder($res);
}

if ($funcion=='add_cita'){		
	$valores=$body['valores'];	
	$columnas="id_producto|id_usuario|id_cliente|id_vendedor|descripcion|estado|detalles|fecha_ini|fecha_fin|hora_ini|hora_fin|nomprecio|descuento|duracion|unidad_dur";	
	$res=insertar("m_citas", $columnas, $valores);	
	echo $res;
}	

if ($funcion=='upd_cita'){		
	$id_cita=$body['id_cita'];
	$estado=$body['estado'];		
	$condicion="WHERE id_cita='".$id_cita."';";		
	$res=actualizar("m_citas", "estado", $estado, $condicion);	
	echo $res;
}



//MOTOR ANTICOLISION DE TIEMPO
if ($funcion=='verifColisionTemporal'){
	$fecha=$body['fecha'];
	$horaini=$body['horaini'];
	$horafin=$body['horafin'];
	$id_usuario=$body['id_usuario'];
	$nummes=$body['nummes'];
	$anio=$body['anio'];
	$ccit=new Ccitas();
	$res=$ccit->verifColisionTemporal($fecha, $horaini, $horafin, $nummes, $anio, $id_usuario);
	echo responder($res); //NO=colisiona, OK=no colisiona
}

//obtiene la ocupacion de ocupacion de un dia
if ($funcion=='get_ocupacionDia'){
	$fecha=$body['fecha'];
	$id_usuario=$body['id_usuario'];
	$nummes=$body['nummes'];
	$anio=$body['anio'];
	$ccit=new Ccitas();
	$res=$ccit->get_contOcupacion($fecha, $nummes, $anio, $id_usuario);
	$ocup=$ccit->getOcupacion($res);	
	echo responder($ocup);
}


//obtiene la ocupacion de ocupacion de un dia
if ($funcion=='get_citaHora'){
	$fecha=$body['fecha'];
	$hora=$body['hora'];
	$id_usuario=$body['id_usuario'];
	$nummes=$body['nummes'];
	$anio=$body['anio'];
	$ccit=new Ccitas();
	$res=$ccit->getCitahora($hora, $fecha, $nummes, $anio, $id_usuario );
	echo responder($res);
}



class Ccitas{
	
	
//MOTOR ANTICOLISIONADOR TEMPORAL

	public function verifColisionTemporal($fecha, $horaini, $horafin, $nummes, $anio, $id_usuario){
		$hini=0;
		$hfin=0;
		$cont=0;
		$verif='OK';		
		$citasmes=$this->getCitasMes($nummes, $anio, $id_usuario); //obtiene ventas del mes anio y usuario especificados	
		$arrcitas=explode(">",$citasmes);
		foreach($arrcitas as $lincita){
			$arrcita=explode("|",$lincita);	
			if ($fecha==date('Y-m-d', strtotime($arrcita[0]))){
				$hini=intval(str_replace(':','',date("H:i", strtotime($arrcita[0]))));
				$hfin=intval(str_replace(':','',date("H:i", strtotime($arrcita[1]))));		
				if ($horaini>$hini and $horaini<$hfin){
					$cont++;					
				}
				if ($horafin>=$hini and $horafin<$hfin){
					$cont++;				
				}
				if ($horaini<$hini and $horafin>$hfin){
					$cont++;					
				}
				if ($horaini==$hini or $horafin==$hfin){
					$cont++;			
				}
			}
		}		
		if($cont>0){
			$verif='NO';			
		}				
		return $verif;
	}
	
	
	public function getCitasMes($nummes, $anio, $id_usuario){		
		$columnas="dv.tiempo_ini, dv.tiempo_fin, v.estado, dv.descripcion, dv.id_venta, dv.id_usuario, dv.id_detalle";		
		$condicion="WHERE MONTH(dv.tiempo_ini)='".$nummes."' and YEAR(dv.tiempo_ini)='".$anio."' and dv.id_usuario='".$id_usuario."' and (v.estado='Pendiente' or v.estado='Completa') order by dv.tiempo_ini asc ;";		
		$tablas="m_ventas v JOIN m_detalle_venta dv ON v.id_venta=dv.id_venta and v.id_usuario=dv.id_usuario";
		$res=consultar($tablas, $columnas, $condicion);		
		return $res;
	}
	
	
	public function get_contOcupacion($fecha, $nummes, $anio, $id_usuario){		
		$citasmes=$this->getCitasMes($nummes, $anio, $id_usuario); //obtiene ventas del mes anio y usuario especificados	
		$arrcitas=explode(">",$citasmes);
		$contmed=0;
		foreach($arrcitas as $lincita){
			$arrcita=explode("|",$lincita);	
			if ($fecha==date('Y-m-d', strtotime($arrcita[0]))){				
				if ($arrcita[2]<>'Completa'){					
					$hini=intval(str_replace(':','',date("H:i", strtotime($arrcita[0]))));
					$hfin=intval(str_replace(':','',date("H:i", strtotime($arrcita[1]))));
					$hiniva=500;
					for($i=5; $i<=23; $i++){						
						if ($hiniva>=$hini and $hiniva<$hfin){
							$contmed++;
						}
						$hiniva=$hiniva+30;
						if($hiniva>=$hini and $hiniva <$hfin){
							$contmed++;
						}		
						$hiniva=$hiniva+100-30;
					}					
				}				
			}			
		}		
		return $contmed;
	}
	
	
	public function getOcupacion($cant){
		$ocupacion='desocupado';
		if ($cant>=1){$ocupacion='semiocupado';}
		if ($cant>=4){$ocupacion='ocupado';}
		if ($cant>=16){$ocupacion='muyocupado';}
		return $ocupacion;
	}
	
	
	public function getCitahora($hora, $fecha, $nummes, $anio, $id_usuario ){
		$citasmes=$this->getCitasMes($nummes, $anio, $id_usuario); //obtiene ventas del mes anio y usuario especificados	
		$arrcitas=explode(">",$citasmes);
		
		$res="";
		foreach($arrcitas as $lincita){
			$arrcita=explode("|",$lincita);	
			if ($fecha==date('Y-m-d', strtotime($arrcita[0]))){
				$hini=intval(str_replace(':','',date("H:i", strtotime($arrcita[0]))));
				$hfin=intval(str_replace(':','',date("H:i", strtotime($arrcita[1]))));
				$hi=date("H:i", strtotime($arrcita[0]));
				$hf=date("H:i", strtotime($arrcita[1]));
				if ($hora >= $hini and $hora <$hfin){
					//CITA: tini, tfin, descripcion, estado, venta, usuario, detalle
					$res=$hi."|".$hf."|".$arrcita[3]."|".$arrcita[2]."|".$arrcita[4]."|".$arrcita[5]."|".$arrcita[6]; 
					break;
				}				
			}
		}
		return $res;	
	}
	
	
	
}

?>