<?php
require('/fpdf/fpdf.php');
require_once "CTimbrado.php";

$body = json_decode(file_get_contents("php://input"), true);
$folio=$body['folio'];  

$ctim= new CTimbrado();
$fact= $ctim->getDatosFact($folio);
$emp=$ctim->getDatosEmpresa(1);
$cli=$ctim->getDatosCliente($fact[20]);
$det=$ctim->getDetalleVenta($fact[18], $fact[19]);
$imp=$ctim->getImpsVenta($fact[18], $fact[19]);


//INICIO DE LA PAGINA
$pdf=new FPDF('P','mm','Letter');
$pdf->AddPage();


//DATOS DE LA EMPRESA
$pdf->Image('mrecursos/imagenes/logorosa.jpg' ,20, 10, 25, 22);

$pdf->SetXY(60,10);
$pdf->SetTextColor(15, 74, 207);
$pdf->SetFont('Arial','',14);
$pdf->Cell(100, 5, $emp[0]); //nombre empresa

$pdf->SetXY(60,15);
$pdf->SetTextColor(0, 0, 0);
$pdf->SetFont('Arial','B',12);
$pdf->Cell(100, 5, 'RFC: '.$emp[1]); //rfc empresa

$pdf->SetXY(60,20);
$pdf->SetFont('Arial','',12);
$pdf->Cell(100, 5, $emp[2].', '.$emp[3].', '.$emp[4]); //calle, num, col  empresa

$pdf->SetXY(60,25);
$pdf->SetFont('Arial','',12);
$pdf->Cell(100, 5, $emp[5].', '.$emp[6].', '.$emp[7].', CP:'.$emp[8]); //mun, edo, pais, cp  empresa

$pdf->SetXY(60,30);
$pdf->SetFont('Arial','B',14);
$pdf->Cell(100, 5, 'FACTURA ELECTRONICA'); 

$pdf->Image('mrecursos/imagenes/encab.jpg' ,10, 37, 190, 2);

// DATOS DE CLIENTE
$pdf->SetXY(10,42);
$pdf->SetFont('Arial','B',12);
$pdf->Cell(100, 5, 'DATOS DEL CLIENTE');

$pdf->SetXY(10,47);
$pdf->SetFont('Arial','',11);
$pdf->Cell(100, 5, $cli[0]); //nombre cliente

$pdf->SetXY(10,52);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, 'RFC: '.$cli[1]); //rfc cliente

$pdf->SetXY(10,57);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, $cli[2].', '.$cli[3].', '.$cli[4]); //dir1 cliente

$pdf->SetXY(10,62);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, $emp[5].', '.$emp[6].', '.$emp[7]); //dir2 cliente

$pdf->SetXY(10,67);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, 'LUGAR DE EXPEDICION: '.$fact[4]); //lugar expedicion

// DATOS DE LA FACTURA
$pdf->SetXY(105,42);
$pdf->SetFont('Arial','B',12);
$pdf->Cell(100, 5, 'DATOS DE LA FACTURA');

$pdf->SetXY(105,47);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, 'SERIE: '.$fact[7]); //serie

$pdf->SetXY(140,47);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, 'FOLIO: '.$fact[2]); //folio

$pdf->SetXY(105,52);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, 'FECHA: '.$fact[21]); //fecha

$pdf->SetXY(105,57);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, 'FORMA PAGO: '.$fact[22]); //fpago

$pdf->SetXY(105,62);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, 'METODO PAGO: '.utf8_decode($fact[23])); //mpago

$pdf->SetXY(105,67);
$pdf->SetFont('Arial','',10);
$pdf->Cell(100, 5, 'REGIMEN FISCAL: '.utf8_decode($fact[24])); //regimen


// DETALLE DE CONCEPTOS
$pdf->Image('mrecursos/imagenes/encab.jpg' ,10, 75, 190, 2);

$pdf->SetXY(10,80);
$pdf->SetFont('Arial','B',12);
$pdf->Cell(100, 5, 'DESCRIPCION DE CONCEPTOS E IMPUESTOS');

//Titulos
$pdf->SetFont('Arial','B',10);
$pdf->SetXY(10,85);
$pdf->Cell(20, 5, 'CLAVE');

$pdf->SetXY(30,85);
$pdf->Cell(20, 5, 'CODIGO');

$pdf->SetXY(50,85);
$pdf->Cell(20, 5, 'CANT');

$pdf->SetXY(70,85);
$pdf->Cell(20, 5, 'UNIDAD');

$pdf->SetXY(90,85);
$pdf->Cell(50, 5, 'DESCRIPCION');

$pdf->SetXY(140,85);
$pdf->Cell(20, 5, 'UNITARIO');

$pdf->SetXY(160,85);
$pdf->Cell(20, 5, 'IMPORTE');

$pdf->SetXY(180,85);
$pdf->Cell(20, 5, 'DESCU');


//Conceptos
$arrde = explode('>',$det);
$Y=90;
$pdf->SetFont('Arial','',9);
foreach($arrde as $lindet){		
	$arrd=explode('|',$lindet);	
	
	$pdf->SetXY(10,$Y);	
	$pdf->Cell(20, 5, $arrd[6]); //clave sat
	
	$pdf->SetXY(30,$Y);
	$pdf->Cell(20, 5, $arrd[2]); //clave prod
	
	$pdf->SetXY(50,$Y);
	$pdf->Cell(20, 5, $arrd[0]); //cant
	
	$pdf->SetXY(70,$Y);
	$pdf->Cell(20, 5, $arrd[1]); //unidad
	
	$pdf->SetXY(90,$Y);
	$pdf->Cell(50, 5, $arrd[3]); //descripcion
	
	$pdf->SetXY(140,$Y);
	$pdf->Cell(20, 5, '$'.$arrd[4]); //unitario
	
	$pdf->SetXY(160,$Y);
	$pdf->Cell(20, 5, '$'.$arrd[5]); //importe
	
	$pdf->SetXY(180,$Y);
	$pdf->Cell(20, 5, '$'.$arrd[9]); //descu
	
	$Y=$Y+3;
}

//Impuestos titulos
$Y=$Y+3;
$pdf->SetFont('Arial','B',8);
$pdf->SetXY(10,$Y);
$pdf->Cell(20, 5, 'IMPUESTO');

$pdf->SetXY(30,$Y);
$pdf->Cell(20, 5, 'FACTOR');

$pdf->SetXY(50,$Y);
$pdf->Cell(20, 5, 'VALOR');

$pdf->SetXY(70,$Y);
$pdf->Cell(20, 5, 'BASE');

$pdf->SetXY(90,$Y);
$pdf->Cell(50, 5, 'IMPORTE');


//Impuestos ciclo
$arrim = explode('>',$imp);
$Y=$Y+5;
$pdf->SetFont('Arial','',8);
foreach($arrim as $linimp){		
	$arri=explode('|',$linimp);	
	
	$pdf->SetXY(10,$Y);	
	$pdf->Cell(20, 3, $arri[1]); //impuesto
	
	$pdf->SetXY(30,$Y);
	$pdf->Cell(20, 3, $arri[2]); //factor
	
	$pdf->SetXY(50,$Y);
	$pdf->Cell(20, 3, $arri[3]); //valor
	
	$pdf->SetXY(70,$Y);
	$pdf->Cell(20, 3, '$'.$arri[3]); //base
	
	$pdf->SetXY(90,$Y);
	$pdf->Cell(50, 3, '$'.$arri[4]); //importe
	
	$Y=$Y+3;
}



//TOTALES Y QR
$Y=$Y+2;
$pdf->Image('mrecursos/imagenes/encab.jpg' ,10, $Y, 190, 2);

$Y=$Y+5;
$pdf->Image('mrecursos/imagenes/qr.png' ,20, $Y, 30, 30);

$pdf->SetFont('Arial','',12);
$pdf->SetXY(130,$Y);
$pdf->Cell(50, 3, 'SUBTOTAL:', 0, 0, 'R'); //subtotal

$pdf->SetXY(180,$Y);
$pdf->Cell(10, 3, '$'.$fact[8]); //subtotal

$Y=$Y+5;
$pdf->SetXY(130,$Y);
$pdf->Cell(50, 3, 'DESCUENTOS:', 0, 0, 'R'); //descuentos

$pdf->SetXY(180,$Y);
$pdf->Cell(10, 3, '$'.$fact[1]); //descuentos

$Y=$Y+5;
$pdf->SetXY(130,$Y);
$pdf->Cell(50, 3, 'TRASLADOS:', 0, 0, 'R'); //traslados

$pdf->SetXY(180,$Y);
$pdf->Cell(10, 3, '$'.$fact[25]); //traslados

$Y=$Y+5;
$pdf->SetXY(130,$Y);
$pdf->Cell(50, 3, 'RETENCIONES:', 0, 0, 'R'); //retenciones

$pdf->SetXY(180,$Y);
$pdf->Cell(10, 3, '$'.$fact[26]); //retenciones

$Y=$Y+5;
$pdf->Image('mrecursos/imagenes/encab.jpg' ,140, $Y, 60, 1);

$Y=$Y+5;
$pdf->SetXY(130,$Y);
$pdf->Cell(50, 3, 'TOTAL:', 0, 0, 'R'); //total

$pdf->SetXY(180,$Y);
$pdf->Cell(10, 3, '$'.$fact[11]); //total


//TIMBRADO
$Y=$Y+8;
$pdf->Image('mrecursos/imagenes/encab.jpg' ,10, $Y, 190, 2);

$Y=$Y+5;
$pdf->SetFont('Arial','',10);
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, 'TOTAL CON LETRA 00/100 MXN'); //total con letra esta pendiente

$Y=$Y+5;
$pdf->SetFont('Arial','B',9);
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, 'Este documento es una representacion impresa de un CFDI'); //leyenda


$Y=$Y+8;
$pdf->SetFont('Arial','',10);
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, 'FOLIO FISCAL: '.$fact[27]); //folio fiscal

$pdf->SetXY(110,$Y);
$pdf->Cell(100, 3, 'FECHA CERTIFICACION: '.$fact[28]); //fecha cert

$Y=$Y+5;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, 'CERTIFICADO DEL SELLO: '.$fact[29]); //certsello

$pdf->SetXY(110,$Y);
$pdf->Cell(100, 3, 'CERTIFICADO DEL SAT: '.$fact[30]); //certsat

$Y=$Y+10;
$pdf->SetFont('Arial','',9);
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, 'SELLO DIGITAL DEL CFDI:'); //sello cfdi


$pdf->SetFont('Arial','',7);
$Y=$Y+5;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($fact[31],0,130));  //sello cfdi
$Y=$Y+3;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($fact[31],130,130));  //sello cfdi
$Y=$Y+3;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($fact[31],260,130));  //sello cfdi


$Y=$Y+5;
$pdf->SetFont('Arial','',9);
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, 'SELLO DIGITAL DEL SAT:'); //sello sat

$pdf->SetFont('Arial','',7);
$Y=$Y+5;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($fact[32],0,130));  //sello sat
$Y=$Y+3;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($fact[32],130,130));  //sello sat
$Y=$Y+3;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($fact[32],260,130));  //sello sat



$Y=$Y+5;
$pdf->SetFont('Arial','',9);
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, 'CADENA ORIGINAL:'); //cadena

$pdf->SetFont('Arial','',7);
$cadena=str_replace('!','|',$fact[33]);
$Y=$Y+5;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($cadena,0,130));  //cadena
$Y=$Y+3;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($cadena,130,130)); //cadena
$Y=$Y+3;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($cadena,260,130));  //cadena
$Y=$Y+3;
$pdf->SetXY(10,$Y);
$pdf->Cell(100, 3, substr($cadena,390,130));  //cadena

//$pdf->output();

$pdf->Output('F','mrecursos/facturas/Mfact8.pdf',true); //fpdf/archivo.pdf
echo 'Guardado';
?>